<?php

/*
  !!!
*/

class MicroSupport_ControllerAdmin_MicroSupport extends XenForo_ControllerAdmin_Abstract
{
	protected function _preDispatch($action)
	{
		$this->assertAdminPermission('microsupport');
	}

    public function actionIndex()
    {
	$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

	    $countfaqcats = $model->getCountAllCats();
	    $countdepartments = $model->getCountAllDepartments();
	    $countdownloads = $model->getCountAllDownloads();
	    $countfaqs = $model->getCountAllFAQs();
	    $countpredefinied = $model->getCountAllPredefinied();
	    $countproducts = $model->getCountAllPoducts();
	    $counttickets = $model->getCountAllTickets();

		$viewParams = array(
			'countfaqcats' => $countfaqcats,
			'countdepartments' => $countdepartments,
			'countdownloads' => $countdownloads,
			'countfaqs' => $countfaqs,
			'countpredefinied' => $countpredefinied,
			'countproducts' => $countproducts,
			'counttickets' => $counttickets,
			'techtotal' => $techtotal,
			'techlimitreached' => $techlimitreached
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_home', $viewParams);
    }

    public function actionLicense()
    {
		$lid = 1;
        $info = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->adminLicenseinfo($lid);

        $viewParams = array(
            'info' => $info
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_license', $viewParams);
    }

    public function actionSavelicense()
    {
        $this->_assertPostOnly();

        $input = $this->_input->filter(array(
            'lid' => XenForo_Input::UINT,
            'microsupport_user_license' => XenForo_Input::STRING,
            'microsupport_buyers_username' => XenForo_Input::STRING,
        ));

        $title = $this->_input->filterSingle('microsupport_buyers_username', XenForo_Input::STRING);

        $dw = XenForo_DataWriter::create('MicroSupport_DataWriter_MicroSupport_License');
        if ($input['lid'])
            $dw->setExistingData($input['lid']);

		$dw->bulkSet($input);
        $dw->save();

        $redirectType = XenForo_ControllerResponse_Redirect::RESOURCE_UPDATED;

        return $this->responseRedirect(
            $redirectType,
            XenForo_Link::buildAdminLink('microsupport/license')
        );


    }

    public function actionStats()
    {
    $now = intval(date('Y'));
	$year = $now;

	$label = array();
	$orderscount = array();
	$orderscounta = array();
	$orderscountb = array();
	$orderscountc = array();
	for($i = 1; $i <= 12; $i++)
    {
        $start = mktime(0, 0, 0, $i, 1, intval($year));
        $startdate = date('Y-m-d', $start);
        $end = mktime(0, 0, 0, $i + 1, 1, intval($year));
        $enddate = date('Y-m-d', $end);
        $label[] = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->getMonthLabel($i);
		$jsitems = 0;
        for($x = 1; $x <= 3; $x++)
        {

		$orderscount[$x] = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->getCountstatsopen($x,strtotime($startdate),strtotime($enddate));
		// ' 1 '.$orderscount[$x].' 2 '.$orderscount[$x].' 3 '.$orderscount[$x].'<br />';
		if($x == 1){
			$orderscounta[] = $orderscount[1];
		}
		if($x == 2){
			$orderscountb[] = $orderscount[2];
		}
		if($x == 3){
			$orderscountc[] = $orderscount[3];
		}

		}

    }
	$totaljan = $orderscounta[0]+$orderscountb[0]+$orderscountc[0];
	$totalfeb = $orderscounta[1]+$orderscountb[1]+$orderscountc[1];
	$totalmar = $orderscounta[2]+$orderscountb[2]+$orderscountc[2];
	$totalapr = $orderscounta[3]+$orderscountb[3]+$orderscountc[3];
	$totalmay = $orderscounta[4]+$orderscountb[4]+$orderscountc[4];
	$totaljun = $orderscounta[5]+$orderscountb[5]+$orderscountc[5];
	$totaljul = $orderscounta[6]+$orderscountb[6]+$orderscountc[6];
	$totalaug = $orderscounta[7]+$orderscountb[7]+$orderscountc[7];
	$totalsep = $orderscounta[8]+$orderscountb[8]+$orderscountc[8];
	$totaloct = $orderscounta[9]+$orderscountb[9]+$orderscountc[9];
	$totalnov = $orderscounta[10]+$orderscountb[10]+$orderscountc[10];
	$totaldec = $orderscounta[11]+$orderscountb[11]+$orderscountc[11];

	$statsdata = "['Month', 'Total Tickets', 'Closed', 'In Progress', 'Open'],
          ['".$label[0]."', ".$totaljan.", ".$orderscountc[0].", ".$orderscountb[0].", ".$orderscounta[0]."],
          ['".$label[1]."', ".$totalfeb.", ".$orderscountc[1].", ".$orderscountb[1].", ".$orderscounta[1]."],
          ['".$label[2]."', ".$totalmar.", ".$orderscountc[2].", ".$orderscountb[2].", ".$orderscounta[2]."],
          ['".$label[3]."', ".$totalapr.", ".$orderscountc[3].", ".$orderscountb[3].", ".$orderscounta[3]."],
          ['".$label[4]."', ".$totalmay.", ".$orderscountc[4].", ".$orderscountb[4].", ".$orderscounta[4]."],
          ['".$label[5]."', ".$totaljun.", ".$orderscountc[5].", ".$orderscountb[5].", ".$orderscounta[5]."],
          ['".$label[6]."', ".$totaljul.", ".$orderscountc[6].", ".$orderscountb[6].", ".$orderscounta[6]."],
          ['".$label[7]."', ".$totalaug.", ".$orderscountc[7].", ".$orderscountb[7].", ".$orderscounta[7]."],
          ['".$label[8]."', ".$totalsep.", ".$orderscountc[8].", ".$orderscountb[8].", ".$orderscounta[8]."],
          ['".$label[9]."', ".$totaloct.", ".$orderscountc[9].", ".$orderscountb[9].", ".$orderscounta[9]."],
          ['".$label[10]."', ".$totalnov.", ".$orderscountc[10].", ".$orderscountb[10].", ".$orderscounta[10]."],
          ['".$label[11]."', ".$totaldec.", ".$orderscountc[11].", ".$orderscountb[11].", ".$orderscounta[11]."]";
		  
		$viewParams = array(
            'year' => $year,
            'statsdata' => $statsdata
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_stats', $viewParams);
    }

    public function actionSettings()
    {
		$id = 1;
        $info = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->adminSettingsinfo($id);

        $viewParams = array(
            'info' => $info
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_settings', $viewParams);
    }

    public function actionSavesettings()
    {
        $this->_assertPostOnly();

        $input = $this->_input->filter(array(
            'id' => XenForo_Input::UINT,
            'onoff' => XenForo_Input::UINT,
            'limit_frontpage' => XenForo_Input::UINT,
            'upload_types' => XenForo_Input::STRING,
            'microsupport_upload_path' => XenForo_Input::STRING,
            'microsupport_departments' => XenForo_Input::UINT,
            'microsupport_products' => XenForo_Input::UINT,
            'microsupport_subemail_subject' => XenForo_Input::STRING,
            'microsupport_subemail_body2' => XenForo_Input::STRING,
            'microsupport_email_salutation' => XenForo_Input::STRING,
            'microsupport_email_subject' => XenForo_Input::STRING,
            'microsupport_email_body2' => XenForo_Input::STRING,
            'microsupport_email_tech' => XenForo_Input::STRING,
            'microsupport_live_welcometext_text' => XenForo_Input::STRING,
            'microsupport_admincp_access' => XenForo_Input::STRING,
            'flashjava' => XenForo_Input::UINT,
            'livechatonoff' => XenForo_Input::UINT,
            'microsupport_downloads' => XenForo_Input::UINT,
            'news' => XenForo_Input::UINT,
        ));

		$input['flashjava'] = 0;

        $dw = XenForo_DataWriter::create('MicroSupport_DataWriter_MicroSupport_Settings');
        if ($input['id'])
            $dw->setExistingData($input['id']);

		$dw->bulkSet($input);
        $dw->save();

        $redirectType = XenForo_ControllerResponse_Redirect::RESOURCE_UPDATED;

        return $this->responseRedirect(
            $redirectType,
            XenForo_Link::buildAdminLink('microsupport/settings')
        );
    }

    public function actionListmess()
    {
        $infos = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->listMessages();

        $viewParams = array(
            'empty' => empty($infos),
            'infos' => $infos
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_messages_list', $viewParams);
    }

    public function actionEditmessage()
    {

        $id = $this->_input->filterSingle('id', XenForo_Input::UINT);
        $info = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->getMessageByID($id);

        $viewParams = array(
            'info' => $info
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_message_edit', $viewParams);

    }

    public function actionSavemessage()
    {
        $this->_assertPostOnly();

        $input = $this->_input->filter(array(
            'id' => XenForo_Input::UINT,
            'title' => XenForo_Input::STRING,
            'bodytext' => XenForo_Input::STRING,
        ));

        $dw = XenForo_DataWriter::create('MicroSupport_DataWriter_MicroSupport_Messages');
        if ($input['id'])
            $dw->setExistingData($input['id']);

        $dw->set('title', $input['title']);
        $dw->set('bodytext', $input['bodytext']);
        $dw->save();

        $redirectType = XenForo_ControllerResponse_Redirect::RESOURCE_UPDATED;

        return $this->responseRedirect(
            $redirectType,
            XenForo_Link::buildAdminLink('microsupport/listmess')
        );
    }

    public function actionListchatbgs()
    {
		$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');


		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);
		if($page == 0 || $page == ''){
		$page = 1;
	}else{
		$page = $page;
	}
		$PerPage = 15;

		$totalFiles = $model->getCountChatbgs();

		$fetchOptions = array(
			'perPage' => $PerPage,
			'totalFiles' => $totalFiles,
			'page' => $page
		);

		$where = '';

		$limit = 'limit ' .($fetchOptions['page'] - 1) * $fetchOptions['perPage'] .',' .$fetchOptions['perPage'];

        $infos = $model->microsupport_admin_get_bgs($where,$limit);

        $viewParams = array(
            'empty' => empty($infos),
			'totalFiles' => $totalFiles,
			'page' => $page,
			'PerPage' => $PerPage,
            'infos' => $infos
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_chatbgs_list', $viewParams);
    }

    public function actionEditchatbg()
    {

        $id = $this->_input->filterSingle('id', XenForo_Input::UINT);
        $info = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->_GetChatbg($id);


		//print_r($ismv);
        $viewParams = array(
            'info' => $info
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_chatbg_edit', $viewParams);

    }

    public function actionAddchatbg()
    {

		$info = '';
		//print_r($ismv);
        $viewParams = array(
            'info' => $info
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_chatbg_edit', $viewParams);

    }

    public function actionSavechatbg()
    {
        $this->_assertPostOnly();

        $input = $this->_input->filter(array(
            'id' => XenForo_Input::UINT,
            'title' => XenForo_Input::STRING,
            'swf' => XenForo_Input::STRING,
            'active' => XenForo_Input::UINT,
        ));

        $dw = XenForo_DataWriter::create('MicroSupport_DataWriter_MicroSupport_Chatbg');
        if ($input['id']){
            $dw->setExistingData($input['id']);
		}

		$dw->bulkSet($input);
        $dw->save();

        $redirectType = XenForo_ControllerResponse_Redirect::RESOURCE_UPDATED;

        return $this->responseRedirect(
            $redirectType,
            XenForo_Link::buildAdminLink('microsupport/listchatbgs')
        );

    }

	public function actionDeletechatbg()
	{
		$id = $this->_input->filterSingle('id', XenForo_Input::STRING);

		$dw = XenForo_DataWriter::create('MicroSupport_DataWriter_MicroSupport_Chatbg');
		$dw->setExistingData($id);

		$dw->delete();

		return $this->responseRedirect(
                XenForo_ControllerResponse_Redirect::SUCCESS,
            XenForo_Link::buildAdminLink('microsupport/listchatbgs')
            );
	}

    public function actionListdownloads()
    {
		$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');


		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);
		if($page == 0 || $page == ''){
		$page = 1;
	}else{
		$page = $page;
	}
		$PerPage = 12;

		$totalFiles = $model->getCountDownloadFiles();

		$fetchOptions = array(
			'perPage' => $PerPage,
			'totalFiles' => $totalFiles,
			'page' => $page
		);

        $infos = $model->AdminlistallFiles($fetchOptions);

        $viewParams = array(
            'empty' => empty($infos),
			'totalFiles' => $totalFiles,
			'page' => $page,
			'PerPage' => $PerPage,
            'infos' => $infos
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_files_list', $viewParams);
    }

    public function actionEditfile()
    {

        $id = $this->_input->filterSingle('id', XenForo_Input::UINT);
        $info = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->admingetDownloadByID($id);

		$settings = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->adminSettingsinfo(1);

		$usergroups = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->listUserGroups();
		$secondaryGroups = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->getSeconderyUsergroups($info['downloadusergroups']);


		//print_r($ismv);
        $viewParams = array(
            'info' => $info,
            'usergroups' => $usergroups,
            'secondaryGroups' => $secondaryGroups
        );

        return $this->responseView('MicroSupport_ViewAdmin_Editfile', 'microsupport_admin_file_edit', $viewParams);

    }

    public function actionAdddownload()
    {

		$settings = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->adminSettingsinfo(1);

		$usergroups = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->listUserGroups();
		$secondaryGroups = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->getSeconderyUsergroups(3);

		$info = array();
		$info['downloaddescription'] = '';
		//print_r($ismv);
        $viewParams = array(
            'info' => $info,
            'usergroups' => $usergroups,
            'secondaryGroups' => $secondaryGroups
        );

        return $this->responseView('MicroSupport_ViewAdmin_Editfile', 'microsupport_admin_file_edit', $viewParams);

    }

    public function actionSaveproduct()
    {
        $this->_assertPostOnly();
		$settings = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->adminSettingsinfo(1);

        $input = $this->_input->filter(array(
            'id' => XenForo_Input::UINT,
            'downloadtitle' => XenForo_Input::STRING,
            'downloaddate' => XenForo_Input::STRING,
            'downloadkey' => XenForo_Input::STRING,
            'downloadcount' => XenForo_Input::UINT,
        ));

		$inputmessage = $this->getHelper('Editor')->getMessageText('message', $this->_input);
		$inputmessage = XenForo_Helper_String::autoLinkBbCode($inputmessage);
		$input['downloaddescription'] = $inputmessage;

    	$input['downloaddate'] = strtotime($input['downloaddate']);

		$_secondaryGroups = $this->_input->filterSingle('aloud_usergroups', XenForo_Input::UINT, array('array' => true));

			$input['downloadusergroups'] = implode(',', $_secondaryGroups);

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		if($input['downloaddate'] == '' || $input['downloaddate'] == 0){
			$input['downloaddate'] = time();
		}else{
			$input['downloaddate'] = $input['downloaddate'];
		}

if(!empty($_FILES["file"]["name"]))
    {
		$file = $_FILES["file"];
		$file = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->uploadFile($file);
		$input['downloadfile'] = $file;
    } else {
		$oldfile = $this->_input->filterSingle('oldfile', XenForo_Input::STRING);
       $input['downloadfile'] = $oldfile;
	}


        $dw = XenForo_DataWriter::create('MicroSupport_DataWriter_MicroSupport_Files');
        if ($input['id']){
            $dw->setExistingData($input['id']);
		}

		$dw->bulkSet($input);
        $dw->save();

        $redirectType = XenForo_ControllerResponse_Redirect::RESOURCE_UPDATED;

        return $this->responseRedirect(
            $redirectType,
            XenForo_Link::buildAdminLink('microsupport/listdownloads')
        );

    }

	public function actionDeletefile()
	{
		$id = $this->_input->filterSingle('id', XenForo_Input::STRING);

	    $file = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->admingetDownloadByID($id);
        $settings = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->adminSettingsinfo(1);
		if(!empty($file['downloadfile'])){
		if (file_exists($settings['microsupport_upload_path'].$file['downloadfile']))
				{
		unlink($settings['microsupport_upload_path'].$file['downloadfile']);
				}
		}

		$dw = XenForo_DataWriter::create('MicroSupport_DataWriter_MicroSupport_Files');
		$dw->setExistingData($id);

		$dw->delete();

		return $this->responseRedirect(
                XenForo_ControllerResponse_Redirect::SUCCESS,
            XenForo_Link::buildAdminLink('microsupport/listdownloads')
            );
	}

    public function actionTicketstatus()
    {
		$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

        $infos = $model->AdminlistallTicketstatus();

        $viewParams = array(
            'empty' => empty($infos),
            'infos' => $infos
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_ticketstatus_list', $viewParams);
    }

    public function actionEditticketstatus()
    {

        $id = $this->_input->filterSingle('id', XenForo_Input::UINT);
        $info = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->admingetTicketstatusByID($id);

		$settings = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->adminSettingsinfo(1);

		//print_r($ismv);
        $viewParams = array(
            'info' => $info
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_ticketstatus_edit', $viewParams);

    }

    public function actionSavets()
    {
        $this->_assertPostOnly();
		$settings = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->adminSettingsinfo(1);

        $input = $this->_input->filter(array(
            'id' => XenForo_Input::UINT,
            'name' => XenForo_Input::STRING,
            'displayorder' => XenForo_Input::UINT,
        ));

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

        $dw = XenForo_DataWriter::create('MicroSupport_DataWriter_MicroSupport_TS');
        if ($input['id']){
            $dw->setExistingData($input['id']);
		}

		$dw->bulkSet($input);
        $dw->save();

        $redirectType = XenForo_ControllerResponse_Redirect::RESOURCE_UPDATED;

        return $this->responseRedirect(
            $redirectType,
            XenForo_Link::buildAdminLink('microsupport/ticketstatus')
        );

    }

    public function actionExtrafields()
    {
		$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');


		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);
		if($page == 0 || $page == ''){
		$page = 1;
	}else{
		$page = $page;
	}
		$PerPage = 12;

		$totalFiles = $model->getCountExtrafields();

		$fetchOptions = array(
			'perPage' => $PerPage,
			'totalFiles' => $totalFiles,
			'page' => $page
		);

        $infos = $model->AdminlistallExtrafields($fetchOptions);

        $viewParams = array(
            'empty' => empty($infos),
			'totalFiles' => $totalFiles,
			'page' => $page,
			'PerPage' => $PerPage,
            'infos' => $infos
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_extrafields_list', $viewParams);
    }

    public function actionEditextrafield()
    {

        $id = $this->_input->filterSingle('id', XenForo_Input::UINT);
        $info = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->admingetExtrafieldByID($id);

		$settings = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->adminSettingsinfo(1);

		//print_r($ismv);
        $viewParams = array(
            'info' => $info
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_extrafield_edit', $viewParams);

    }

    public function actionSaveextrafield()
    {
        $this->_assertPostOnly();
		$settings = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->adminSettingsinfo(1);

        $input = $this->_input->filter(array(
            'id' => XenForo_Input::UINT,
            'title' => XenForo_Input::STRING,
            'description' => XenForo_Input::STRING,
            'size' => XenForo_Input::UINT,
            'type' => XenForo_Input::UINT,
            'options' => XenForo_Input::STRING,
            'displayorder' => XenForo_Input::UINT,
        ));

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

        $dw = XenForo_DataWriter::create('MicroSupport_DataWriter_MicroSupport_ExtraField');
        if ($input['id']){
            $dw->setExistingData($input['id']);
		}

		$dw->bulkSet($input);
        $dw->save();

        $redirectType = XenForo_ControllerResponse_Redirect::RESOURCE_UPDATED;

        return $this->responseRedirect(
            $redirectType,
            XenForo_Link::buildAdminLink('microsupport/extrafields')
        );

    }

	public function actionDeleteextrafield()
	{
		$id = $this->_input->filterSingle('id', XenForo_Input::STRING);

		$dw = XenForo_DataWriter::create('MicroSupport_DataWriter_MicroSupport_ExtraField');
		$dw->setExistingData($id);

		$dw->delete();

		return $this->responseRedirect(
                XenForo_ControllerResponse_Redirect::SUCCESS,
            XenForo_Link::buildAdminLink('microsupport/extrafields')
            );
	}

    public function actionAddextrafield()
    {
		//print_r($ismv);
        $viewParams = array(
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_extrafield_edit', $viewParams);

    }

    public function actionProducts()
    {
		$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');


		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);
		if($page == 0 || $page == ''){
		$page = 1;
	}else{
		$page = $page;
	}
		$PerPage = 12;

		$totalFiles = $model->getCountproducts();

		$fetchOptions = array(
			'perPage' => $PerPage,
			'totalFiles' => $totalFiles,
			'page' => $page
		);

        $infos = $model->Adminlistallproducts($fetchOptions);

        $viewParams = array(
            'empty' => empty($infos),
			'totalFiles' => $totalFiles,
			'page' => $page,
			'PerPage' => $PerPage,
            'infos' => $infos
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_products_list', $viewParams);
    }

    public function actionEditproduct()
    {

        $id = $this->_input->filterSingle('id', XenForo_Input::UINT);
        $info = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->admingetProductByID($id);

		$settings = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->adminSettingsinfo(1);

		//print_r($ismv);
        $viewParams = array(
            'info' => $info
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_product_edit', $viewParams);

    }

    public function actionSaveprod()
    {
        $this->_assertPostOnly();
		$settings = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->adminSettingsinfo(1);

        $input = $this->_input->filter(array(
            'id' => XenForo_Input::UINT,
            'name' => XenForo_Input::STRING,
            'displayorder' => XenForo_Input::UINT,
        ));

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

        $dw = XenForo_DataWriter::create('MicroSupport_DataWriter_MicroSupport_Product');
        if ($input['id']){
            $dw->setExistingData($input['id']);
		}

		$dw->bulkSet($input);
        $dw->save();

        $redirectType = XenForo_ControllerResponse_Redirect::RESOURCE_UPDATED;

        return $this->responseRedirect(
            $redirectType,
            XenForo_Link::buildAdminLink('microsupport/products')
        );

    }

	public function actionDeleteproduct()
	{
		$id = $this->_input->filterSingle('id', XenForo_Input::STRING);

		$dw = XenForo_DataWriter::create('MicroSupport_DataWriter_MicroSupport_Product');
		$dw->setExistingData($id);

		$dw->delete();

		return $this->responseRedirect(
                XenForo_ControllerResponse_Redirect::SUCCESS,
            XenForo_Link::buildAdminLink('microsupport/products')
            );
	}

    public function actionAddproduct()
    {
		//print_r($ismv);
        $viewParams = array(
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_product_edit', $viewParams);

    }

    public function actionDepartments()
    {
		$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);
		if($page == 0 || $page == ''){
		$page = 1;
	}else{
		$page = $page;
	}
		$PerPage = 12;

		$totalFiles = $model->getCountDepartments();

		$fetchOptions = array(
			'perPage' => $PerPage,
			'totalFiles' => $totalFiles,
			'page' => $page
		);

        $infos = $model->AdminlistallDepartments($fetchOptions);

        $viewParams = array(
            'empty' => empty($infos),
			'totalFiles' => $totalFiles,
			'page' => $page,
			'PerPage' => $PerPage,
            'infos' => $infos,
            'techlimitreached' => $techlimitreached,
            'techtotal' => $techtotal
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_departments_list', $viewParams);
    }

    public function actionEditdepartment()
    {

        $id = $this->_input->filterSingle('id', XenForo_Input::UINT);
        $info = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->admingetDepartmentByID($id);

		$settings = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->adminSettingsinfo(1);

		//print_r($ismv);
        $viewParams = array(
            'info' => $info
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_department_edit', $viewParams);

    }

    public function actionSavedepartment()
    {
        $this->_assertPostOnly();
		$settings = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->adminSettingsinfo(1);

        $input = $this->_input->filter(array(
            'id' => XenForo_Input::UINT,
            'name' => XenForo_Input::STRING,
            'emails' => XenForo_Input::STRING,
            'displayorder' => XenForo_Input::UINT,
        ));

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

        $dw = XenForo_DataWriter::create('MicroSupport_DataWriter_MicroSupport_Department');
        if ($input['id']){
            $dw->setExistingData($input['id']);
		}

		$dw->bulkSet($input);
        $dw->save();

        $redirectType = XenForo_ControllerResponse_Redirect::RESOURCE_UPDATED;

        return $this->responseRedirect(
            $redirectType,
            XenForo_Link::buildAdminLink('microsupport/departments')
        );

    }

	public function actionDeletedepartment()
	{
		$id = $this->_input->filterSingle('id', XenForo_Input::STRING);

		$dw = XenForo_DataWriter::create('MicroSupport_DataWriter_MicroSupport_Department');
		$dw->setExistingData($id);

		$dw->delete();

		return $this->responseRedirect(
                XenForo_ControllerResponse_Redirect::SUCCESS,
            XenForo_Link::buildAdminLink('microsupport/departments')
            );
	}

    public function actionAdddepartment()
    {
		//print_r($ismv);
        $viewParams = array(
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_department_edit', $viewParams);

    }

    public function actionCategories()
    {
		$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');


		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);
		if($page == 0 || $page == ''){
		$page = 1;
	}else{
		$page = $page;
	}
		$PerPage = 10;

		$totalFiles = $model->getCountCategories();

		$fetchOptions = array(
			'perPage' => $PerPage,
			'totalFiles' => $totalFiles,
			'page' => $page
		);

        $infos = $model->AdminlistallCategories($fetchOptions);

        $viewParams = array(
            'empty' => empty($infos),
			'totalFiles' => $totalFiles,
			'page' => $page,
			'PerPage' => $PerPage,
            'infos' => $infos
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_categories_list', $viewParams);
    }

    public function actionEditfaqcat()
    {
		$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);

		$current = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->admingetFAQCatByID($id);

        $allcategories = $model->AdminlistallFAQCategories();

        $viewParams = array(
			'current' => $current,
			'allcategories' => $allcategories
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_categories_edit', $viewParams);
    }

    public function actionAddfaqcat()
    {
		$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

		$parentid = $this->_input->filterSingle('parentid', XenForo_Input::UINT);

		$current = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->admingetFAQCatByID($parentid);

        $allcategories = $model->AdminlistallFAQCategories();

        $viewParams = array(
			'current' => $current,
			'allcategories' => $allcategories
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_categories_add', $viewParams);
    }

    public function actionDoaddfaqcat()
    {
        $this->_assertPostOnly();
		$settings = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->adminSettingsinfo(1);

        $input = $this->_input->filter(array(
            'id' => XenForo_Input::UINT,
            'name' => XenForo_Input::STRING,
            'parentid' => XenForo_Input::UINT,
            'displayorder' => XenForo_Input::UINT,
        ));

		if($input['parentid'] == 0){
		$input['depth'] = 0;
		}else{
		$current = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->admingetFAQCatByID($input['parentid']);
		$input['depth'] = $current['depth']+1;
		}

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

        $dw = XenForo_DataWriter::create('MicroSupport_DataWriter_MicroSupport_Categories');
        if ($input['id']){
            $dw->setExistingData($input['id']);
		}

		$dw->bulkSet($input);
        $dw->save();

        $redirectType = XenForo_ControllerResponse_Redirect::RESOURCE_UPDATED;

        return $this->responseRedirect(
            $redirectType,
            XenForo_Link::buildAdminLink('microsupport/categories')
        );

    }

    public function actionSavefaqcat()
    {
        $this->_assertPostOnly();
		$settings = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->adminSettingsinfo(1);

        $input = $this->_input->filter(array(
            'id' => XenForo_Input::UINT,
            'name' => XenForo_Input::STRING,
            'parentid' => XenForo_Input::UINT,
            'displayorder' => XenForo_Input::UINT,
        ));

		if($input['parentid'] == 0){
		$input['depth'] = 0;
		}else{
		$current = $this->getModelFromCache('MicroSupport_Model_MicroSupport')->admingetFAQCatByID($input['parentid']);
		$input['depth'] = $current['depth']+1;
		}

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

        $dw = XenForo_DataWriter::create('MicroSupport_DataWriter_MicroSupport_Categories');
        if ($input['id']){
            $dw->setExistingData($input['id']);
		}

		$dw->bulkSet($input);
        $dw->save();

        $redirectType = XenForo_ControllerResponse_Redirect::RESOURCE_UPDATED;

        return $this->responseRedirect(
            $redirectType,
            XenForo_Link::buildAdminLink('microsupport/categories')
        );

    }

	public function actionDeletefaqcat()
	{
		$id = $this->_input->filterSingle('id', XenForo_Input::STRING);

		$dw = XenForo_DataWriter::create('MicroSupport_DataWriter_MicroSupport_Categories');
		$dw->setExistingData($id);

		$dw->delete();

		return $this->responseRedirect(
                XenForo_ControllerResponse_Redirect::SUCCESS,
            XenForo_Link::buildAdminLink('microsupport/categories')
            );
	}

    public function actionChatarchive()
    {
		$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');


		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);
		if($page == 0 || $page == ''){
		$page = 1;
	}else{
		$page = $page;
	}
		$PerPage = 10;

		$totalFiles = $model->getCountChatarchives();

		$fetchOptions = array(
			'perPage' => $PerPage,
			'totalFiles' => $totalFiles,
			'page' => $page
		);

        $infos = $model->AdminlistallChatarchives($fetchOptions);

        $viewParams = array(
            'empty' => empty($infos),
			'totalFiles' => $totalFiles,
			'page' => $page,
			'PerPage' => $PerPage,
            'infos' => $infos
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_chatarchives_list', $viewParams);
    }

    public function actionViewarchive()
    {
		$adminid = $this->_input->filterSingle('adminid', XenForo_Input::UINT);
		$userid = $this->_input->filterSingle('userid', XenForo_Input::UINT);

		$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');


		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);
		if($page == 0 || $page == ''){
		$page = 1;
	}else{
		$page = $page;
	}
		$PerPage = 20;

		$totalFiles = $model->getCountUserChatarchives($userid,$adminid);

		$fetchOptions = array(
			'perPage' => $PerPage,
			'totalFiles' => $totalFiles,
			'page' => $page
		);

        $infos = $model->AdminlistallUserChatarchives($userid,$adminid,$fetchOptions);

        $viewParams = array(
            'empty' => empty($infos),
			'totalFiles' => $totalFiles,
			'page' => $page,
			'PerPage' => $PerPage,
            'infos' => $infos
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_userchatarchives_list', $viewParams);
    }

	public function actionDeletearchive()
	{
		$adminid = $this->_input->filterSingle('adminid', XenForo_Input::UINT);
		$userid = $this->_input->filterSingle('userid', XenForo_Input::UINT);
		$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

		$model->AdminDeleteUserChatarchives($userid,$adminid);

		return $this->responseRedirect(
                XenForo_ControllerResponse_Redirect::SUCCESS,
            XenForo_Link::buildAdminLink('microsupport/chatarchive')
            );
	}

    public function actionUsermap()
    {
	$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	    $mapusers = $model->getmapusers();

		$viewParams = array(
			'mapusers' => $mapusers
        );

        return $this->responseView('MicroSupport_ViewAdmin_Index', 'microsupport_admin_usermap', $viewParams);
    }

}
