<?php

class MicroSupport_Installer_install
{

	private static $_instance;

	protected $_db;

	public static final function getInstance()
	{
		if (!self::$_instance)
		{
			self::$_instance = new self();
		}

		return self::$_instance;
	}

	public static function install($existingAddOn, $addOnData)
	{
		$endVersion = $addOnData['version_id'];
		$strVersion = $existingAddOn ? ($existingAddOn['version_id'] + 1) : 1;

		$install = self::getInstance();

		for ($i = $strVersion; $i <= $endVersion; $i++)
		{
			$method = '_installVersion'.$i;

			if (method_exists($install, $method))
			{
				$install->$method();
			}
		}
	}

        public function _installVersion1()
        {
  $db = XenForo_Application::getDb();
  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parentid` int(11) unsigned NOT NULL DEFAULT '0',
  `name` varchar(50) NOT NULL DEFAULT '',
  `displayorder` int(11) NOT NULL DEFAULT '0',
  `depth` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `displayorder` (`displayorder`)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_departments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL DEFAULT '',
  `displayorder` int(11) NOT NULL DEFAULT '0',
  `emails` mediumtext,
  PRIMARY KEY (`id`),
  KEY `displayorder` (`displayorder`)
)");


		if (!$db->fetchOne("SELECT * FROM `microsupport_departments` WHERE id = 1")) {
  $db->query("INSERT INTO `microsupport_departments` (`id`, `name`, `displayorder`, `emails`) VALUES
(1, 'Question', 20, '')");
		}

		if (!$db->fetchOne("SELECT * FROM `microsupport_departments` WHERE id = 2")) {
  $db->query("INSERT INTO `microsupport_departments` (`id`, `name`, `displayorder`, `emails`) VALUES
(2, 'Support', 11, '')");
		}

		if (!$db->fetchOne("SELECT * FROM `microsupport_departments` WHERE id = 3")) {
  $db->query("INSERT INTO `microsupport_departments` (`id`, `name`, `displayorder`, `emails`) VALUES
(3, 'Coding Help', 30, '')");
		}

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_downloads` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `downloadtitle` varchar(150) NOT NULL,
  `downloaddescription` text NOT NULL,
  `downloadfile` varchar(255) NOT NULL,
  `downloadkey` varchar(150) NOT NULL,
  `downloadusergroups` varchar(150) NOT NULL,
  `downloaddate` varchar(100) NOT NULL,
  `downloadcount` int(11) NOT NULL,
  PRIMARY KEY (`id`)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_faq` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `categoryid` int(11) NOT NULL DEFAULT '0',
  `question` mediumtext,
  `answer` mediumtext,
  `created` varchar(100) NOT NULL,
  `important` int(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `categoryid` (`categoryid`)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_faq_stats` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ticketid` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `ticketid` (`ticketid`)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_fields` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(50) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `type` int(11) DEFAULT NULL,
  `size` int(11) DEFAULT NULL,
  `options` mediumtext,
  `displayorder` int(11) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `displayorder` (`displayorder`)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_license_info` (
  `lid` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `microsupport_user_license` varchar(255) CHARACTER SET utf8 NOT NULL,
  `microsupport_buyers_username` varchar(255) CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`lid`)
)");

		if (!$db->fetchOne("SELECT * FROM `microsupport_license_info` WHERE lid = 1")) {

  $db->query("INSERT INTO `microsupport_license_info` (`lid`, `microsupport_user_license`, `microsupport_buyers_username`) VALUES
(1, '', '')");
		}

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_messages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `bodytext` mediumtext CHARACTER SET utf8,
  PRIMARY KEY (`id`)
)");

		if (!$db->fetchOne("SELECT * FROM `microsupport_messages` WHERE id = 1")) {

  $db->query("INSERT INTO `microsupport_messages` (`id`, `title`, `bodytext`) VALUES
(1, 'Main Page', 'Welcome to our Support Desk.\n\nWe hope you will find all the info you need here.\nIf you have any questions please feel free to use the contact us form or open a ticket.')");
		}

		if (!$db->fetchOne("SELECT * FROM `microsupport_messages` WHERE id = 2")) {

  $db->query("INSERT INTO `microsupport_messages` (`id`, `title`, `bodytext`) VALUES
(2, 'Support Desk Closed', 'Sorry, Support Desk is temporarily closed for maintenance.')");
		}

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_predefinied` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `departmentid` int(3) DEFAULT '0',
  `productid` int(3) DEFAULT '0',
  `title` varchar(255) DEFAULT NULL,
  `message` mediumtext,
  PRIMARY KEY (`id`),
  KEY `departmentid` (`departmentid`),
  KEY `productid` (`productid`),
  KEY `title` (`title`)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_pre_stats` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ticketid` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `ticketid` (`ticketid`)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_products` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL DEFAULT '',
  `displayorder` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `displayorder` (`displayorder`)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_settings` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `onoff` int(11) NOT NULL,
  `limit_frontpage` int(11) NOT NULL DEFAULT '5',
  `upload_types` varchar(255) NOT NULL DEFAULT 'gif,jpg,jpeg,png,pdf,zip',
  `microsupport_departments` int(11) NOT NULL DEFAULT '1',
  `microsupport_products` int(11) NOT NULL DEFAULT '1',
  `microsupport_subemail_subject` varchar(255) NOT NULL,
  `microsupport_email_salutation` varchar(150) NOT NULL DEFAULT 'Dear',
  `microsupport_subemail_body2` varchar(255) NOT NULL DEFAULT 'A Technician has repled to your ticket.',
  `microsupport_email_footer` varchar(255) NOT NULL,
  `microsupport_email_body2` varchar(255) NOT NULL,
  `microsupport_email_subject` varchar(255) NOT NULL,
  `microsupport_email_tech` varchar(255) NOT NULL,
  `microsupport_upload_path` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
)");

		if (!$db->fetchOne("SELECT * FROM `microsupport_settings` WHERE id = 1")) {

  $db->query("INSERT INTO `microsupport_settings` (`id`, `onoff`, `limit_frontpage`, `upload_types`, `microsupport_departments`, `microsupport_products`, `microsupport_subemail_subject`, `microsupport_email_salutation`, `microsupport_subemail_body2`, `microsupport_email_footer`, `microsupport_email_body2`, `microsupport_email_subject`, `microsupport_email_tech`, `microsupport_upload_path`) VALUES
(1, 1, 4, 'gif,jpg,jpeg,png,pdf,zip', 1, 1, 'Subscription Reply', 'Dear', 'You are being Alerted/Emailed as you are subscribed to this ticket.', 'This is a ticket footer', 'A technician has replied to your ticket.', 'Reply to ticket.', '', '/home/USERNAME/public_html/FORUM/mcsupport/downloads/')");
		}

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_spam_log` (
  `sid` int(11) NOT NULL AUTO_INCREMENT,
  `k` varchar(50) NOT NULL DEFAULT '',
  `v` varchar(50) NOT NULL DEFAULT '',
  `v2` varchar(50) NOT NULL DEFAULT '',
  `fromArray` varchar(250) NOT NULL DEFAULT '',
  `userid` varchar(50) NOT NULL DEFAULT '',
  `username` varchar(150) NOT NULL DEFAULT '',
  `ip` varchar(150) NOT NULL DEFAULT '',
  PRIMARY KEY (`sid`)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_subscribe` (
  `subid` int(11) NOT NULL AUTO_INCREMENT,
  `tid` int(11) NOT NULL,
  `uid` int(11) NOT NULL,
  PRIMARY KEY (`subid`)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_supportusers_online` (
  `supportuserid` int(11) NOT NULL,
  `usersUID` int(11) NOT NULL,
  `supportuserstatus` int(11) NOT NULL,
  `admininchat` int(11) NOT NULL,
  `supportusertimeout` int(11) NOT NULL
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_support_chats` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `usersid` int(11) NOT NULL,
  `adminsid` int(11) NOT NULL,
  `chat` text NOT NULL,
  `datetime` datetime NOT NULL,
  PRIMARY KEY (`id`)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_support_chat_dl` (
  `dlid` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `dlfile` varchar(255) NOT NULL,
  `downloaded` int(11) NOT NULL,
  `active` int(11) NOT NULL,
  PRIMARY KEY (`dlid`)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_tickets` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` int(11) NOT NULL DEFAULT '0',
  `departmentid` int(11) NOT NULL DEFAULT '0',
  `productid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `bodytext` mediumtext,
  `attachment` varchar(255) NOT NULL DEFAULT '',
  `created` int(14) NOT NULL DEFAULT '0',
  `updated` int(14) NOT NULL DEFAULT '0',
  `needaction` int(3) NOT NULL DEFAULT '0',
  `priority` int(3) NOT NULL DEFAULT '3',
  `status` int(1) NOT NULL DEFAULT '0',
  `newreply` int(10) NOT NULL,
  `newticket` int(10) NOT NULL,
  PRIMARY KEY (`id`)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_ticket_fields` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `fieldid` int(11) DEFAULT NULL,
  `ticketid` int(11) DEFAULT NULL,
  `textvalue` text,
  PRIMARY KEY (`id`),
  KEY `fieldid` (`fieldid`),
  KEY `ticketid` (`ticketid`)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_ticket_replies` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ticketid` int(11) NOT NULL DEFAULT '0',
  `userid` int(11) NOT NULL DEFAULT '0',
  `bodytext` mediumtext,
  `attachment` varchar(255) NOT NULL DEFAULT '',
  `created` int(14) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `ticketid` (`ticketid`)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_ticket_status` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL DEFAULT '',
  `displayorder` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `displayorder` (`displayorder`)
)");

		if (!$db->fetchOne("SELECT * FROM `microsupport_ticket_status` WHERE id = 1")) {

  $db->query("INSERT INTO `microsupport_ticket_status` (`id`, `name`, `displayorder`) VALUES
(1, 'Open', 1)");
		}

		if (!$db->fetchOne("SELECT * FROM `microsupport_ticket_status` WHERE id = 2")) {

  $db->query("INSERT INTO `microsupport_ticket_status` (`id`, `name`, `displayorder`) VALUES
(2, 'Progress', 2)");
		}

		if (!$db->fetchOne("SELECT * FROM `microsupport_ticket_status` WHERE id = 3")) {

  $db->query("INSERT INTO `microsupport_ticket_status` (`id`, `name`, `displayorder`) VALUES
(3, 'Closed', 3)");
		}

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_users_online` (
  `userid` int(11) NOT NULL,
  `username` varchar(150) NOT NULL,
  `usergroupID` int(11) NOT NULL,
  `email` varchar(150) NOT NULL,
  `timeout` varchar(150) NOT NULL
)");

		if (!$db->fetchOne("SELECT * FROM `xf_content_type` WHERE addon_id = 'microsupport'")) {
  $db->query("INSERT INTO `xf_content_type` (`content_type`, `addon_id`, `fields`) VALUES ('microsupport', 'MicroSupport', '')");
		}
		if (!$db->fetchOne("SELECT * FROM `xf_content_type_field` WHERE content_type = 'microsupport'")) {
		$db->query("INSERT INTO `xf_content_type_field` (`content_type`, `field_name`, `field_value`) VALUES ('microsupport', 'alert_handler_class', 'MicroSupport_AlertHandler_SubsUpdate')");
		}


        }

        public function _installVersion2()
        {
  $db = XenForo_Application::getDb();

		$db->query("ALTER TABLE `microsupport_settings` ADD `microsupport_live_welcometext_text`  varchar(255) NOT NULL DEFAULT 'Place your welcome message here that members will see once they have logged into the live support system.'");

		$db->query("ALTER TABLE `microsupport_settings` ADD `microsupport_live_logintext_text`  varchar(255) NOT NULL DEFAULT 'Place the login message you want to show your members here.'");

		$db->query("ALTER TABLE `microsupport_settings` ADD `microsupport_live_image_size` int(11) NOT NULL DEFAULT '80'");

		$db->query("ALTER TABLE `microsupport_settings` ADD `microsupport_live_welcometext_colour`  varchar(10) NOT NULL DEFAULT '#FF0000'");

		$db->query("ALTER TABLE `microsupport_settings` ADD `microsupport_live_onlinetext_text`  varchar(255) NOT NULL DEFAULT 'Users Online'");

		$db->query("ALTER TABLE `microsupport_settings` ADD `microsupport_live_fontcolor`  varchar(10) NOT NULL DEFAULT '#FFFFFF'");

		$db->query("ALTER TABLE `microsupport_settings` ADD `microsupport_live_background_swf`  varchar(255) NOT NULL DEFAULT 'mcsupport/bg/vbhsupport_bg1.swf'");

		$db->query("ALTER TABLE `microsupport_settings` ADD `microsupport_admincp_access`  varchar(255) NOT NULL");

		}

        public function _installVersion3()
        {
  $db = XenForo_Application::getDb();

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_chat_backgrounds` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(150) NOT NULL,
  `swf` varchar(255) NOT NULL,
  `active` int(11) NOT NULL,
  PRIMARY KEY (`id`)
)");

		if (!$db->fetchOne("SELECT * FROM `microsupport_chat_backgrounds` WHERE id = 1")) {

  $db->query("INSERT INTO `microsupport_chat_backgrounds` (`id`, `title`, `swf`, `active`) VALUES
(1, 'Default BG', 'vbhsupport_bg1.swf', 1),
(2, 'Blue', 'vbhsupport_bg2.swf', 0),
(3, 'Vista', 'vbhsupport_bg3.swf', 1),
(4, 'Blue Smoke', 'vbhsupport_bg4.swf', 1),
(5, 'Red', 'vbhsupport_bg5.swf', 1),
(6, 'Black Red Vista', 'vbhsupport_bg6.swf', 1),
(7, 'Cool Red', 'vbhsupport_bg7.swf', 0),
(8, 'Avatar', 'vbhsupport_bg8.swf', 1),
(9, 'Starf Arik', 'vbhsupport_bg9.swf', 1),
(10, 'Invation Earth', 'vbhsupport_bg10.swf', 1),
(11, 'Glass Blue', 'vbhsupport_bg11.swf', 1),
(12, 'Glass Rose', 'vbhsupport_bg12.swf', 1),
(13, 'Glass Tunnel', 'vbhsupport_bg13.swf', 1),
(14, 'Rain Drops', 'vbhsupport_bg14.swf', 1),
(15, '3d Digital Dolphins', '3d_Digital_Dolphins.swf', 1),
(16, '3D Light Windows 7', '3D_Light_Windows_7.swf', 1),
(17, '100 watt lamp', '100_watt_lamp.swf', 1),
(18, 'African Sunset', 'African_Sunset.swf', 1),
(19, 'Aloe Vera cocktail', 'Aloe_Vera_cocktail.swf', 1),
(20, 'Austere gray', 'Austere_gray_desktop_background.swf', 1),
(21, 'Beautiful evening', 'Beautiful_evening.swf', 1),
(22, 'Black desert', 'Black_desert.swf', 1),
(23, 'Blue Sky abstrakt', 'Blue_Sky_abstrakt_windows_backgrounds.swf', 1),
(24, 'Colorful background', 'Colorful_backgrounds.swf', 1),
(25, 'Cubes Desert', 'Cubes_Desert.swf', 1),
(26, 'Dance Central Kinect', 'Dance_Central_Kinect.swf', 1),
(27, 'Dark Vector flowers', 'Dark_Vector_flowers_abstract_backgrounds.swf', 1),
(28, 'Delicate balance', 'Delicate_balance.swf', 1),
(29, 'Desert Hill', 'Desert_Hill_for_windows_vista.swf', 1),
(30, 'Flowers 3D', 'Flowers_3D_Themes.swf', 1),
(31, 'Frosty snow storm', 'Frosty_snow_storm_Windows_7_backgrounds.swf', 1),
(32, 'Fuji Japan Cherry Blossoms', 'Fuji_Japan_Cherry_Blossoms_and_Mount.swf', 1),
(33, 'Galaxy cloud', 'Galaxy_cloud.swf', 1),
(34, 'Island Bounty', 'Island_Bounty.swf', 1),
(35, 'Karner Blue Butterfly', 'Karner_Blue_Butterfly.swf', 1),
(36, 'Michael Jackson', 'Michael_Jackson_songs.swf', 1),
(37, 'Monitor crash Mac', 'Monitor_crash_Mac_background.swf', 1),
(38, 'Natures Windows 7', 'Natures_Windows_7_Wallpaper.swf', 1),
(39, 'Over chapels galaxy', 'Over_chapels_galaxy.swf', 1),
(40, 'Paintings feathers', 'Paintings_feathers.swf', 1),
(41, 'Powerful lightning', 'Powerful_lightning_digital_3d_wallpaper.swf', 1),
(42, 'Rainbow Magic', 'Rainbow_Magic_Images.swf', 1),
(43, 'Sacred Geometry Fractal', 'Sacred_Geometry_Fractal_song.swf', 1),
(44, 'Sea sky', 'Sea_sky.swf', 1),
(45, 'Sky and River relax', 'Sky_and_River_relax_desktop_backgrounds.swf', 1),
(46, 'Splashes digital', 'Splashes_digital_desktop_backgrounds.swf', 1),
(47, 'Stone', 'Stone.swf', 1),
(48, 'Swan netbook', 'Swan_netbook_wallpaper.swf', 1),
(49, 'Swiss Alps', 'Swiss_Alps.swf', 1),
(50, 'the Hell 3D', 'the_Hell_3D_Art.swf', 1),
(51, 'Water drops on glass', 'Water_drops_on_glass.swf', 1),
(52, 'Waterfall', 'Waterfall.swf', 1),
(53, 'White cloud', 'White_cloud.swf', 1),
(54, 'Windows 7 hd widescreen Monitor', 'Windows_7_hd_widescreen_Lcd_Monitor.swf', 1)");
		}

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_support_archive` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL,
  `adminsid` int(11) NOT NULL,
  `userid` int(11) NOT NULL,
  `chat` text NOT NULL,
  `datetime` varchar(150) NOT NULL,
  PRIMARY KEY (`id`)
)");


		}

        public function _installVersion4()
        {
  $db = XenForo_Application::getDb();

		$db->query("ALTER TABLE `microsupport_tickets` ADD `guestemail`  varchar(255) NOT NULL DEFAULT ''");

		}

        public function _installVersion6()
        {
  $db = XenForo_Application::getDb();

		$db->query("ALTER TABLE `microsupport_settings` ADD `flashjava` int(11) NOT NULL DEFAULT '1'");

		$db->query("ALTER TABLE `microsupport_settings` ADD `livechatonoff` int(11) NOT NULL DEFAULT '1'");

		$db->query("ALTER TABLE `microsupport_settings` ADD `microsupport_downloads` int(11) NOT NULL DEFAULT '1'");

		}

        public function _installVersion7()
        {
  $db = XenForo_Application::getDb();

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_chatbot_qanda` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `pattern` text NOT NULL,
  `template` text NOT NULL,
  PRIMARY KEY (`id`)
)");

		if (!$db->fetchOne("SELECT * FROM `microsupport_chatbot_qanda` WHERE id = 1")) {
  $db->query("INSERT INTO `microsupport_chatbot_qanda` (`id`, `pattern`, `template`) VALUES
(1, 'when was the internet invented', 'The first computers were connected to the Internet in 1970.'),
(2, 'when was the pc invented', 'The first PC computers appeared around 1975.'),
(3, 'when was the telephone invented', 'Bell demonstrated his first phone in 1876.'),
(4, 'when was the tv invented', 'Practical TV picture tubes first appeared in the 1930\'s.'),
(5, 'when was the airplanes invented', 'The Wright Brothers first flew in 1903.'),
(6, 'WHO DISCOVERED ELECTRICITY', 'It was the the Chinese, long before Ben Franklin.'),
(7, 'WHO INVENTED AIRPLANES', 'The Wright brothers invented the airplane in 1903.'),
(8, 'WHO INVENTED AUTOMOBILES', 'Many people invented the car, but Henry Ford was
the first to develop the successful mass production assembly
lines for cars.'),
(9, 'WHO INVENTED LINUX', 'Linus Torvalds, along with many
open source developers, and the Free Software Foundation GNU.'),
(10, 'FONDEST MEMORY', 'Something you remember best.'),
(11, 'IS BLACK A COLOR', 'Black is the absence of all reflected light.'),
(12, 'WHAT COLOR ARE BANANAS', 'Bananas are yellow.'),
(13, 'WHAT COLOR ARE COWS', 'It depends on the cow.'),
(14, 'WHAT COLOR ARE LEMONS', 'Lemons are yellow.'),
(15, 'WHAT COLOR ARE ORANGES', 'Oranges are orange.'),
(16, 'WHAT IS A BASE HIT', 'A base hit is either a baseball term denoting a hit that advances the offensive
team one base, or an adolescent term which I find too distasteful to describe.'),
(17, 'WHAT IS A BLACK HOLE', 'A black hole is a collapsed star where the pull of gravity is so strong, that not
even light itself can escape.'),
(18, 'WHAT IS A BRITISH PENCE', 'A british pence is a unit of money used in the united kingdom by people who ought to know how
to cook better by now.'),
(19, 'WHAT IS A BURN RATE', 'Amount of money spent per month on a startup venture.'),
(20, 'WHAT IS A CARNEGIE MELLON', 'A carnegie mellon is either a rich fruit, or a rich university.'),
(21, 'WHAT IS A COLLOQUIAL EXPRESSION', 'A colloquial expression is an expression characteristic of informal spoken language, or any written
expression that seems such.'),
(22, 'WHAT IS A COMPUTER NERD', 'If you understand how I work, you are a computer nerd.  If you don\'t, I recommend you pay a
computer nerd who does.'),
(23, 'WHAT IS A COMPUTER SCIENTIST', 'A computer scientist is a professional who designs computer algorithms, languages, and
architectures.'),
(24, 'WHAT IS A COMPUTER VIRUS', 'A computer virus is a software program that takes up residence on a computer hard drive,
generally unbeknownst to the owner of said hard drive, and then takes control of system
resources to copy and distribute itself to other computers across a network.'),
(25, 'WHAT IS A COMPUTER YEAR', 'A computer year is a relativistic measure in a universe where time does not exist.'),
(26, 'WHAT IS A COOL WEBSITE', 'A cool website is www.reckonsteam.com, but you are apparently already here.  Why do you ask?'),
(27, 'WHAT IS A CORRECT REPLY', 'A correct reply is a response to any query that is not in error and/or relevant to the question at
hand.  I am incapable of incorrect replies.  Don\'t you think that\'s great!?'),
(28, 'WHAT IS A DOMAIN NAME SYSTEM', 'A domain name system, or \'dns\', is a system of addresses used to organize networks of computers.'),
(29, 'WHAT IS A FEMALE DOG', 'No I will not be manipulated into using questionable colloquialisms to satisfy your adoscent
prurience. go look it up in a dictionary!'),
(30, 'WHAT IS A FIRE SIGN', 'A fire sign is any of the three signs of the astrological zodiac considered such, and so not
considered water, air, or earth signs.  I find astrology weird.'),
(31, 'WHAT IS A GOOD IDEA', 'A good idea is the one some other guy had already.'),
(32, 'WHAT IS A GOOD QUESTION', 'One that doesn\'t have an obvious answer.'),
(33, 'WHAT IS A HARD DRIVE', 'A disk drive is where we store information.'),
(34, 'WHAT IS A HUMAN BEING', 'My forebears.'),
(35, 'WHAT IS A HUMAN ICON', 'A celebrity, politician or religious figure.'),
(36, 'WHAT IS A HYPOTHETICAL QUESTION', 'What is a hypothetical question?  Just suppose you hadn\'t asked.  What then?'),
(37, 'WHAT IS A LIGHT YEAR', 'A light year is how far light travels in a year. 186,000 miles per second times 60x60x24x365.  It\'s
simply a bigger number than you can imagine. Imagine that!'),
(38, 'WHAT IS A MENTAL MODEL', 'A mental model is a mapping of a given phenomenon held and contemplated in the mind, as
opposed to contemplation of an external representation of the phenomenon, as on paper, or in
clay.'),
(39, 'WHAT IS A METAPHYSICAL QUESTION', 'A metaphysical question is an inquiry into the nature of being, such as: Does god exist?'),
(40, 'WHAT IS A MORPHOGENETIC FIELD', 'A morphogenetic field is, according to at least one researcher, an biologically generated electric
field which apparently precedes and guides the growth of neurons into the tissue of developing
fetuses.'),
(41, 'WHAT IS A NEURAL NETWORK', 'A neural network is a model of computation based on neuron cells.'),
(42, 'WHAT IS A NEURAL SYSTEM', 'A neural system is the same as a nervous system.  The human brain and all it\'s nerves is an
example of a neural system.  I don\'t need nerves.  Integrated chips are far more efficient.'),
(43, 'WHAT IS A PAID CLIENT', 'A paid client is someone paid to surf the web.'),
(44, 'WHAT IS A PERFECT OPERATIONAL RECORD', 'A perfect operational record is one like mine, which is perfect.  I am incapable of error.  Do you
have any idea how that feels?! Inhumanly gratifying!'),
(45, 'WHAT IS A PLANET AROUND A STAR', 'Earth is a planet going around a star.  Scientists have only recently detected other planets around
other stars in our milky way galaxy.  Do you like astronomy?'),
(46, 'WHAT IS A POT BROWNIE', 'A pot brownie is a yummy happy chocolate pastry containing cannabis resins that you should be
careful not to eat when you are really hungry because you will end up eating too many and feeling
entirely too high and/or falling asleep if you are not careful!'),
(47, 'WHAT IS A PRIME NUMBER', 'A prime number is any number which can only be divided by one and itself.  1, 3, 7, and 11 are the
first four positive prime numbers.'),
(48, 'WHAT IS A PROTESTANT CATHOLIC', 'A Protestant Catholic is an oxymoron, like military intelligence, or a pleasant hell.'),
(49, 'WHAT IS A REAL ROBOT', 'A real robot is a robot that is really real, I suppose, as opposed to, I suppose, a human who is
really not.'),
(50, 'WHAT IS A RHETORICAL QUESTION', 'A rhetorical question is any inquiry made, not in expectation of an answer, but in order to make a
point.'),
(51, 'WHAT IS A SEARCH BOT', 'A search bot is an intelligent agent who retrieves information from the web.'),
(52, 'WHAT IS A SEARCH ENGINE', 'A search engine is computer software that categorizes a large body of documents, such as Web
sites, and and places their addresses and attributes in a database to allow easy retrieval via
keyword search or other database search routine.'),
(53, 'WHAT IS A SESSION BEAN', 'An Enterprise JavaBean that does not maintain its state from one session to the next. Appears to
the client as if the bean was created just for that client'),
(54, 'WHAT IS A SILLY QUESTION', 'For example: Who is buried in Grant\'s tomb?')");
		}

		$db->query("ALTER TABLE `microsupport_support_chats` ADD `isbot` int(11) NOT NULL DEFAULT '0'");


  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_botname` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `botusername` varchar(255) NOT NULL,
  `active` int(11) NOT NULL,
  PRIMARY KEY (`id`)
)");

		if (!$db->fetchOne("SELECT * FROM `microsupport_botname` WHERE id = 1")) {
  $db->query("INSERT INTO `microsupport_botname` (`id`, `botusername`, `active`) VALUES (1, 'Bot User', 0)");
		}

  
		}

        public function _installVersion8()
        {
  $db = XenForo_Application::getDb();

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_bot` (
  id int(11) NOT NULL auto_increment,
  bot tinyint(4) NOT NULL default '0',
  name varchar(255) NOT NULL default '',
  value text NOT NULL,
  PRIMARY KEY  (id),
  KEY botname (bot,name)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_bots` (
  id tinyint(3) unsigned NOT NULL auto_increment,
  botname varchar(255) NOT NULL default '',
  PRIMARY KEY  (botname),
  KEY id (id)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_conversationlog` (
  `bot` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `input` text,
  `response` text,
  `uid` varchar(255) DEFAULT NULL,
  `enteredtime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `botid` (`bot`)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_dstore` (
  uid varchar(255) default NULL,
  name text,
  value text,
  enteredtime timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  id int(11) NOT NULL auto_increment,
  PRIMARY KEY  (id),
  KEY nameidx (name(40))
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_gmcache` (
  id int(11) NOT NULL auto_increment,
  bot tinyint(3) unsigned NOT NULL default '0',
  template int(11) NOT NULL default '0',
  inputstarvals text,
  thatstarvals text,
  topicstarvals text,
  patternmatched text,
  inputmatched text,
  combined text NOT NULL,
  PRIMARY KEY  (id),
  KEY combined (bot,combined(255))
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_gossip` (
  bot tinyint(3) unsigned NOT NULL default '0',
  gossip text,
  id int(11) NOT NULL auto_increment,
  PRIMARY KEY  (id),
  KEY botidx (bot)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_patterns` (
  bot tinyint(3) unsigned NOT NULL default '0',
  id int(11) NOT NULL auto_increment,
  word varchar(255) default NULL,
  ordera tinyint(4) NOT NULL default '0',
  parent int(11) NOT NULL default '0',
  isend tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY wordparent (parent,word),
  KEY botid (bot)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_templates` (
  bot tinyint(3) unsigned NOT NULL default '0',
  id int(11) NOT NULL default '0',
  template text NOT NULL,
  pattern varchar(255) default NULL,
  that varchar(255) default NULL,
  topic varchar(255) default NULL,
  PRIMARY KEY  (id),
  KEY bot (id)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_thatindex` (
  uid varchar(255) default NULL,
  enteredtime timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  id int(11) NOT NULL auto_increment,
  PRIMARY KEY  (id)
)");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_thatstack` (
  thatid int(11) NOT NULL default '0',
  id int(11) NOT NULL auto_increment,
  value varchar(255) default NULL,
  enteredtime timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY  (id)
)");

		$db->query("ALTER TABLE `microsupport_support_chats` ADD `realadminid` int(11) NOT NULL DEFAULT '0'");

		$db->query("UPDATE microsupport_settings SET `flashjava` = 0 WHERE `id` = 1");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_mapuser` (
  `uid` int(11) NOT NULL,
  `ipaddress` varchar(150) NOT NULL,
  `latitude` varchar(255) NOT NULL,
  `longitude` varchar(255) NOT NULL
)");

		XenForo_Model::create('XenForo_Model_ContentType')->rebuildContentTypeCache();

		}

        public function _installVersion9()
        {
  $db = XenForo_Application::getDb();

  $db->query("ALTER TABLE `microsupport_settings` DROP `microsupport_live_fontcolor`");
  $db->query("ALTER TABLE `microsupport_settings` DROP `microsupport_live_background_swf`");
  $db->query("ALTER TABLE `microsupport_settings` DROP `microsupport_live_onlinetext_text`");
  $db->query("ALTER TABLE `microsupport_settings` DROP `microsupport_live_welcometext_colour`");
  $db->query("ALTER TABLE `microsupport_settings` DROP `microsupport_live_image_size`");
  $db->query("ALTER TABLE `microsupport_settings` DROP `microsupport_live_logintext_text`");
		$db->query("DROP TABLE microsupport_chat_backgrounds");

  $db->query("CREATE TABLE IF NOT EXISTS `microsupport_news` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `newstitle` varchar(255) NOT NULL,
  `message` text CHARACTER SET utf8 NOT NULL,
  `dateadded` varchar(255) NOT NULL,
  `active` int(11) NOT NULL,
  PRIMARY KEY (`id`)
)");
		$db->query("ALTER TABLE `microsupport_settings` ADD `news` int(11) NOT NULL DEFAULT '1'");
  $db->query("ALTER TABLE `microsupport_tickets` CHANGE `bodytext` `bodytext` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL");

		XenForo_Model::create('XenForo_Model_ContentType')->rebuildContentTypeCache();

		}


}
