<?php
/**
* This is our callback class.
* We must define a callback class to be used in the code event listener.
*/
class MicroSupport_Listener_MSSidbarListener
{
	/**
	 * This is our callback method. It uses 4 params. This method will check if the current requested hook is what we want ('forum_list_sidebar')
	 * and if it is, we will insert in the contents our template. This way we will have a sidebar right after the XenForo default sidebar.
	 *
	 */
	public static function LiveSupportHook($hookName, &$contents, array $hookParams, XenForo_Template_Abstract $template)
	{
		/* If this hook is what we want! Remember: we have found the hook name when we was looking in the forum_list template! */
		if ($hookName == 'forum_list_sidebar')
		{
			$model = XenForo_Model::create('MicroSupport_Model_MicroSupport');
        	$mcssettings = $model->adminSettingsinfo(1);
        
			$adminsonline = $model->microsupport_supportusers_online();

			$hookParams['adminsonline'] = $adminsonline;
			$hookParams['mcssettings'] = $mcssettings;

			/* Insert our template in the contents. This way our sidebar will be inserted right after the last XenForo sidebar in the forum list page */
			$params = $template->getParams();
			$params += $hookParams;

$contents .= $template->create('microsupport_livechat_forumsidebar', $params);

			/* If you want that our sidebar be BEFORE the XenForo sidebars uncomment the following line (don't forget to comment the line above) */
			//$contents = $template->create('newsidebar_sidebar') . $contents;
		}
	}


	public static function LivejavaSupportHook($hookName, &$contents, array $hookParams, XenForo_Template_Abstract $template)
	{
		/* If this hook is what we want! Remember: we have found the hook name when we was looking in the forum_list template! */
		if ($hookName == 'moderator_bar')
		{
			$model = XenForo_Model::create('MicroSupport_Model_MicroSupport');
        	$settings = $model->adminSettingsinfo(1);
			$visitor = XenForo_Visitor::getInstance();
			$userid = $visitor['user_id'];
        
			$adminsonline = $model->microsupport_supportadvisers_online();
        
			$checkadminlogin = $model->microsupport_supportadvisers_onlineadmin($userid);

			$hookParams['adminsonline'] = $adminsonline;
			$hookParams['checkadminlogin'] = $checkadminlogin;

			$hookParams['settings'] = $settings;

			/* Insert our template in the contents. This way our sidebar will be inserted right after the last XenForo sidebar in the forum list page */
			$params = $template->getParams();
			$params += $hookParams;

$contents .= $template->create('microsupport_livechat_moderator_bar', $params);

			/* If you want that our sidebar be BEFORE the XenForo sidebars uncomment the following line (don't forget to comment the line above) */
			//$contents = $template->create('newsidebar_sidebar') . $contents;
		}
	}
}