<?php

class MicroSupport_Listener_MicroSupport
{
    public static function navigationTabs(array &$extraTabs, $selectedTabId)
    {
		$permsModel = XenForo_Model::create('MicroSupport_Model_MicroSupport');
		$perms = $permsModel->adminSettingsinfo(1);

        $extraTabs['support'] = array(
            'title' => new XenForo_Phrase('microsupport_navbar'),
            'href' => XenForo_Link::buildPublicLink('full:support'),
			'perms' => $perms,
            'linksTemplate' => 'microsupport_navigation_tabs',
        );
    }


	public static function widget_framework_ready(array &$renderers) {
		$renderers[] = 'MicroSupport_WidgetRenderer_Livesupport';
		$renderers[] = 'MicroSupport_WidgetRenderer_Responcetime';
		$renderers[] = 'MicroSupport_WidgetRenderer_LatestNews';
		$renderers[] = 'MicroSupport_WidgetRenderer_Importants';
		$renderers[] = 'MicroSupport_WidgetRenderer_LatestQuestions';
		$renderers[] = 'MicroSupport_WidgetRenderer_LatestDownloads';
	}

	public static function MCSupportPostHook($hookName, &$contents, array $hookParams, XenForo_Template_Abstract $template)
	{
		/* If this hook is what we want! Remember: we have found the hook name when we was looking in the forum_list template! */
		if ($hookName == 'post_private_controls')
		{
			$model = XenForo_Model::create('MicroSupport_Model_MicroSupport');
        	$mcssettings = $model->adminSettingsinfo(1);
        $departments = $model->getdepartments();
        $products = $model->getProducts();

			$hookParams['mcssettings'] = $mcssettings;
			$hookParams['departments'] = $departments;
			$hookParams['products'] = $products;

			/* Insert our template in the contents. This way our sidebar will be inserted right after the last XenForo sidebar in the forum list page */
			$params = $template->getParams();
			$params += $hookParams;

$contents .= $template->create('microsupport_post_toticket', $params);

			/* If you want that our sidebar be BEFORE the XenForo sidebars uncomment the following line (don't forget to comment the line above) */
			//$contents = $template->create('newsidebar_sidebar') . $contents;
		}
	}
}
